//forum thread:30969
//'this' filename:30969_Heiken_Ashi_Smoothed.mq4
//derived from:
//original source downloaded from:
//http://codebase.mql4.com/2754
//+------------------------------------------------------------------+
//|                                         Heiken Ashi Smoothed.mq4 |
//|                                                                  |
//|                                                      mod by Raff |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"
//----
#property indicator_chart_window
//#property indicator_buffers 4
#property indicator_buffers 6
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_color3 Red
#property indicator_color4 Lime
#property indicator_color5 Blue     //arrowUp[] aka:index buffer 4 --> iCustom(...,4,shift)
#property indicator_color6 Red      //arrowDn[] aka:index buffer 5 --> iCustom(...,5,shift)
//---- parameters
extern int MaMetod =2;
extern int MaPeriod=6;
extern int MaMetod2 =3;
extern int MaPeriod2=2;
//---- buffers
double arrowUp[],arrowDn[];//,signal[];            //via iCustom() is possible to 'see' if arrow plotted at shift'x'
                                                   //IF you intend to use iCustom() to grab its values THEN is iCustom(...,int mode=6,shift)
                                                   //for any element: IF plotted arrow THEN expect <>0 ELSE is 0
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];
//----
int ExtCountedBars=0;

//int firstStart = true;
bool firstStart = true;       //although true is 1 and false is 0 numerically, the variable type "bool" is used, since is boolean
                              //usage...



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
  {
//---- indicators
   IndicatorBuffers(8);
   SetIndexStyle(0,DRAW_HISTOGRAM, 0, 1, Red);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM, 0, 1, Lime);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM, 0, 3, Red);
   SetIndexBuffer(2, ExtMapBuffer3);
   SetIndexStyle(3,DRAW_HISTOGRAM, 0, 3, Lime);
   SetIndexBuffer(3, ExtMapBuffer4);

    SetIndexBuffer(4,arrowUp);
    SetIndexStyle(4,DRAW_ARROW);
    SetIndexArrow(4,233); //241 option for different arrow head
    SetIndexBuffer(5,arrowDn);
    SetIndexStyle(5,DRAW_ARROW);
    SetIndexArrow(5,234); //242 option for different arrow head      
///----
   SetIndexDrawBegin(0,5);
//---- indicator buffers mapping
//   SetIndexBuffer(0,ExtMapBuffer1);     //not needed as done above
//   SetIndexBuffer(1,ExtMapBuffer2);     //..
//   SetIndexBuffer(2,ExtMapBuffer3);     //..
//   SetIndexBuffer(3,ExtMapBuffer4);     //..

//these to become 
   SetIndexBuffer(6,ExtMapBuffer5);       //bumped up to last two available indicator buffers
   SetIndexBuffer(7,ExtMapBuffer6);       //..
   //SetIndexBuffer(4,ExtMapBuffer5);
   //SetIndexBuffer(5,ExtMapBuffer6);
//   SetIndexBuffer(6,ExtMapBuffer7);     //these two which are "two more" than the max of 8 indicator buffers
//   SetIndexBuffer(7,ExtMapBuffer8);     //are sized to Bars and set as series arrays.
                                          //All we've done is bump two of the calculation buffers off the indicator buffer list
                                          //by the UP,DN buffers which must be in this list.
                                          //Setting & resizing these two calculation bufrs as series arrays
                                          //is all that is needed to emulate their original usage.
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double maOpen, maClose, maLow, maHigh;
   double haOpen, haHigh, haLow, haClose;
   if(Bars<=10) return(0);
   ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);



if(firstStart == true)
{
   //ArrayResize(ExtMapBuffer5,Bars);
   //ArraySetAsSeries(ExtMapBuffer5,true);     //The setAsSeries reverses the indexing sense of the array so it's identical to the normal IndicatorBuffers.

   //ArrayResize(ExtMapBuffer6,Bars);              
   //ArraySetAsSeries(ExtMapBuffer5,true);          

   ArrayResize(ExtMapBuffer7,Bars);          //these are the two bumped off the indicator buffers list
   ArraySetAsSeries(ExtMapBuffer7,true);     //..

   ArrayResize(ExtMapBuffer8,Bars);          //..
   ArraySetAsSeries(ExtMapBuffer8,true);     //..
   
   firstStart = false;
}




//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   int pos=Bars-ExtCountedBars-1;
   while(pos>=0)
     {
      maOpen=iMA(NULL,0,MaPeriod,0,MaMetod,MODE_OPEN,pos);
      maClose=iMA(NULL,0,MaPeriod,0,MaMetod,MODE_CLOSE,pos);
      maLow=iMA(NULL,0,MaPeriod,0,MaMetod,MODE_LOW,pos);
      maHigh=iMA(NULL,0,MaPeriod,0,MaMetod,MODE_HIGH,pos);
//----
      haOpen=(ExtMapBuffer5[pos+1]+ExtMapBuffer6[pos+1])/2;
      haClose=(maOpen+maHigh+maLow+maClose)/4;
      haHigh=MathMax(maHigh, MathMax(haOpen, haClose));
      haLow=MathMin(maLow, MathMin(haOpen, haClose));
      if (haOpen<haClose)
        {
         ExtMapBuffer7[pos]=haLow;
         ExtMapBuffer8[pos]=haHigh;
         arrowUp[pos]= haLow - 10 * MarketInfo(Symbol(),MODE_POINT);             //YOUR code
         arrowDn[pos]= 0;                                                        //..
        }
      else
        {
         ExtMapBuffer7[pos]=haHigh;
         ExtMapBuffer8[pos]=haLow;
         arrowUp[pos]= 0;                                                        //YOUR code
         arrowDn[pos]= haHigh + 10 * MarketInfo(Symbol(),MODE_POINT);            //..
        }
      ExtMapBuffer5[pos]=haOpen;
      ExtMapBuffer6[pos]=haClose;
      pos--;
     }
   int i;
   for(i=0; i<Bars; i++) ExtMapBuffer1[i]=iMAOnArray(ExtMapBuffer7,Bars,MaPeriod2,0,MaMetod2,i);
   for(i=0; i<Bars; i++) ExtMapBuffer2[i]=iMAOnArray(ExtMapBuffer8,Bars,MaPeriod2,0,MaMetod2,i);
   for(i=0; i<Bars; i++) ExtMapBuffer3[i]=iMAOnArray(ExtMapBuffer5,Bars,MaPeriod2,0,MaMetod2,i);
   for(i=0; i<Bars; i++) ExtMapBuffer4[i]=iMAOnArray(ExtMapBuffer6,Bars,MaPeriod2,0,MaMetod2,i);
//----
   return(0);
  }
//+------------------------------------------------------------------+